--
-- The following VHDL code was generated by
-- BRUSEY20 - PIC to VHDL Parser - v2.5
-- Copyright (C) 1999 by Tom Mayo
--
-- To contact the author:  tcmayo@servtech.com
--
--                         Tom Mayo
--                         2172 Prospect St.
--                         Penfield, NY  14526
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of version 2 of the GNU General Public License as
-- published by the Free Software Foundation.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY your_entity IS
  PORT (
    clk : IN std_logic;
    boo : IN std_logic;
    a : OUT std_logic;
    b : OUT std_logic
  );
END your_entity;

ARCHITECTURE exemplar OF your_entity IS

  TYPE state_type IS ( s1, s2 );
  SIGNAL current_state, next_state : state_type;
  SIGNAL next_a : std_logic;
  SIGNAL next_b : std_logic;

BEGIN

  registers : PROCESS ( clk, boo )
  BEGIN
    IF ( boo = '1' ) THEN
      a <= '0';
      b <= '1';
      current_state <= s1;
    ELSIF ( clk'EVENT AND clk = '1' ) THEN
      a <= next_a;
      b <= next_b;
      current_state <= next_state;
    END IF;
  END PROCESS;

  transitions : PROCESS ( current_state )
  BEGIN
    CASE current_state IS
      WHEN s1 =>
        next_a <= '1';
        next_b <= '0';
        next_state <= s2;
      WHEN s2 =>
        next_a <= '0';
        next_b <= '1';
        next_state <= s1;
    END CASE;
  END PROCESS;
END exemplar;
